title: L'effondrement, parlons-en...
author:  Jérémie Cravatte
tags: écologie
         collapsologie
headline: Les limites de la "collapsologie".
read_on: Octobre 2019
link: http://www.barricade.be/publications/analyses-etudes/effondrement-parlons-limites-collapsologie

## La collapsologie comme science

> […] Cela a pour effet de donner l’impression à l’audience qu’elle prend
connaissance d’une réalité objectivée (et donc méthodologiquement vérifiable)
plutôt que d’un discours. Cela implique, par exemple, que des raccourcis opérés
entre plusieurs phénomènes […] tiendraient de la méthode scientifique plutôt que de l’interprétation. Comme le souligne Elisabeth Lagasse , le melting-pot opéré entre sciences naturelles et sciences sociales induit une naturalisation des rapports sociaux qui n’est plus discutée. Assumer qu’il s’agit d’interprétations à mettre en débat serait bien plus utile. En lieu et place de cela, les personnes qui critiquent ces interprétations sont régulièrement accusées d’être dans le « déni ».

> Enfin, cette ambiguïté nourrit le sentiment que l’effondrement généralisé est une
hypothèse, un modèle qui se vérifiera ou non, un événement qui aura lieu ou non.
On appelle d’ailleurs ces discours « théories de l’effondrement ». Or, la question
n’est pas là. La situation écologique et sociale n’est pas une hypothèse.

## Raccourcis / Confusionnisme

>Les discours collapsos amalgament malheureusement sous ce mot valise d’effondrement des changements irréversibles – qu’on ne peut, en effet, que tenter de limiter et préparer (comme la destruction de la biodiversité et l’emballement climatique) – avec des changements totalement réversibles (comme la montée des fascismes, le transhumanisme ou la financiarisation du monde). 

> « Si la finance s’effondre, ça fait des effets de contagion qui font des effondrements économiques. Effondrement financier, c’est quand il n’y a plus rien dans les guichets automatiques, c’est l’Argentine en 2001. Si ça se propage à un effondrement économique par les chaînes d’approvisionnement, ben ça fait plus rien dans les magasins. Et là tu te poses des questions, est-ce qu’on souhaite ça ? Ça peut dégénérer, en chaos social, politique. L’effondrement politique c’est l’URSS en 1989, t’as un retour des mafias etc. Si on va plus loin, l’effondrement social c’est la Lybie, c’est Mad Max quoi, y’a plus d’État, y’a plus rien. Qu’est-ce qu’on souhaite, qu’est-ce qu’on souhaite pas ? [...] Le problème c’est que tout est inter-connecté. Tu souhaites l’effondrement du capitalisme ? Mais si il s’effondre, il y aura d’autres choses qui vont s’effondrer parce que tout est lié. » (Pablo Servigne)

Passage qui montre qu'il y a une sorte de confusionnisme dans le discours de Servigne.

> La confusion porte sur la notion de « civilisation thermo-industrielle » et sa prétendue fin. Les discours de l’effondrement présentent une série de constats angoissants (à raison) puis expliquent (à tort) que cela correspond à « l’effondrement de notre civilisation thermo-industrielle ». Cette manière de présenter les choses – qui associe une mauvaise et une bonne nouvelle (la fin du monde et la fin de cette « civilisation » destructrice) – provoque, au mieux, une confusion entre les deux, au pire, un désir de trouver un peu de répit pour cette « civilisation » à laquelle le public s’identifie.

## Dépolitisation

> Faire croire que « tout va s’effondrer » d’un bloc, comme un bâtiment, donner l’impression aux personnes qu’elles n’ont aucune prise sur la situation présente et à venir, c’est alimenter le sentiment d’impuissance, la croyance que nous sommes face à une impasse plutôt que face à une multitude de chemins.

> L’approche fourre-tout de l’effondrement dépolitise la question écologique appelant, dans un élan de prétendue « lucidité », à faire le deuil de choses inévitables et de choses évitables. S’agit-il de faire le deuil des services publics tout en continuant à payer des impôts, d’un climat tempéré, de la majorité des espèces vivantes, de « nos » proches, de la moitié la plus pauvre ou la plus riche de l’humanité en premier lieu, du « confort » d’un système de santé équitable ou à deux vitesses... ? […] il s’agit un peu confusément de tout cela à la fois, sans précisions.

> Pour reprendre la fameuse métaphore de l’incendie, si les Colibris nous appellent
à faire notre part individuellement plutôt que le nécessaire collectivement, les récits
collapsos nous appellent (individuellement et collectivement) à accepter l’incendie et
à préparer la renaissance qui y ferait suite. Ce qui brûle dans cet incendie (et, surtout,
dans quel ordre), on n’en parle pas trop.

> Nombre de collapsos parlent de « verrouillages » complexes de la société actuelle
(sociaux, techniques et politiques) pour justifier leur posture d’acceptation. Cela pour-
rait signifier, par exemple, que lutter pour exproprier et socialiser les multinationales
de l’énergie (afin de les démanteler ou de les reconvertir, selon les cas) constituerait
du « marchandage » (la troisième étape du processus de deuil), c’est-à-dire une forme
de déni de l’aspect inextricable (verrouillé) de la situation. 

> Même lorsqu’on est convaincu·e que les choses sont « verrouillées », il est intellec-
tuellement malhonnête – en plus d’être irresponsable – d’invisibiliser les interactions,
conflits, solidarités, résistances existantes (et à venir) qui modifient la situation et les
manières dont les basculements écologiques sont et seront vécus.

