title: Comment la non-violence protège l'état
headline: Essai sur l'inefficacité des mouvements sociaux
author: Peter Gelderloos
tags: non-violence
      critique
isbn: 978-2-9556782-4-4
image: https://www.editionslibre.org/wp-content/uploads/2018/02/siteinternet4.png
read_on: Juin 2019

> On peut discerner un schéma récurrent de manipulation historique et de blanchiment flagrant dans chacune des victoires revendiquées par les activistes non-violent-e-s. **La position pacifiste requiert que le succès doit pouvoir être attribué aux tactiques pacifistes et à elles seules, alors que nous autres pensons que le changement provient de l’ensemble des tactiques utilisées dans toute situation révolutionnaire, pourvu qu’elles soient déployées de façon efficace**. Parce qu’aucun conflit social majeur ne présente une uniformité de tactiques et d’idéologies – autrement dit on trouve dans tous les conflits de ce genre le recours à des tactiques pacifistes et à des tactiques résolument non-pacifistes –, les pacifistes doivent effacer la part d’histoire qui est en désaccord avec leurs affirmations ou au contraire attribuer leurs échecs à la présence au sein du mouvement concerné d’une forme de lutte violente.

> On nous raconte qu’en Inde, guidés par leur leader Gandhi, les gens construisirent au fil des décennies un mouvement non-violent de masse et s’engagèrent dans la protestation, la non-coopération, les boycotts économiques, des grèves de la faim exemplaires et des actes de désobéissance pour bloquer la machinerie de l’impérialisme britannique. Ils subirent des massacres et répliquèrent par une ou deux émeutes mais, dans l’ensemble, le mouvement fut non-violent et, après avoir persévéré pendant des décennies, le peuple indien gagna son indépendance, délivrant ainsi une victoire pacifiste certifiée. L’histoire réelle est plus compliquée, puisque **des poussées violentes ont également influencé la décision de retrait des Britanniques**. Ceux-ci avaient perdu la capacité de maintenir leur pouvoir colonial, après que des millions de leurs soldats meurent et qu'une grande quantité de ressources diverses soient anéanties au cours de deux guerres mondiales extrêmement violentes, dont la seconde dévasta tout spécialement la « mère patrie ». Les luttes armées des militant-e-s arabes et juifs en Palestine entre 1945 et 1948 continuèrent d’affaiblir l’empire britannique, et rendirent alors évidente la menace que les Indien-ne-s pourraient abandonner la désobéissance civile et prendre les armes en masse si l'on continuait de les ignorer encore longtemps ; tout ceci ne peut être exclu des facteurs qui déterminèrent la décision des Britanniques de renoncer à une administration coloniale directe.
> On réalise que cette menace était encore plus directe lorsque l’on comprend que **l’histoire pacifiste du mouvement d’indépendance indien brosse un tableau sélectif et incomplet** : la non-violence n’était pas universelle en Inde. La résistance à la colonisation britannique comprenait bien assez de lutte violente ou armée pour que l’on considère de façon plus exacte que la méthode gandhienne était l’une des différentes formes concurrentes de résistance populaire. Dans leur dérangeante démarche d’universalisation, **les pacifistes effacent ces autres formes de résistance et contribuent à propager l’histoire fausse selon laquelle Gandhi et ses disciples étaient la seule boussole de la résistance indienne**. Sont ainsi passés sous silence d’importants dirigeants militants comme Chandrasekhar Azad 7 , qui combattit les armes à la main contre les colons britanniques, et **des révolutionnaires comme Bhagat Singh, qui s’attira un soutien massif en commettant des attentats à la bombe et des assassinats au profit d’une lutte visant le renversement du capitalisme tant indien que britannique**.
> L’histoire pacifiste de la lutte indienne ne peut rendre compte du fait que Subhas Chandra Bose, le candidat favorable à l'usage de méthodes de luttes non exclusivement pacifiques, fut élu deux fois président du Congrès National Indien, en 1938 et 1939. Si Gandhi fut peut-être la figure la plus remarquablement influente et populaire dans la lutte pour l’indépendance de l’Inde, la position dirigeante qu’il assuma ne lui valut pas toujours un soutien unanime des masses. Il perdit tellement de soutien des Indien-ne-s lorsqu’il appela au calme après l’émeute de 1922 que « pas le moindre murmure de protestation ne se fit entendre en Inde quand les Britanniques l’arrêtèrent ensuite » .

> De façon significative, l’histoire se souvient de Gandhi plus que de tous les autres non pas parce qu’il représentait la voix unanime de l’Inde, mais de par l’attention particulière que lui porta la presse britannique et la prééminence que lui valut le fait d’être pris comme interlocuteur lors d’importantes négociations avec le gouvernement colonial britannique. Si l’on se rappelle que l’histoire est écrite par les vainqueurs, une autre strate du mythe de l’indépendance indienne s’effrite.

> Mais **l’aspect le plus désolant de l'affirmation des pacifistes** que l’indépendance de l’Inde est une victoire pour la non-violence **est qu’elle donne tête baissée dans la manipulation historique** élaborée dans l’intérêt des États impérialistes et partisans de la suprématie blanche, qui ont colonisé les pays du Sud. Le mouvement de libération de l’Inde échoua. **Les Britanniques ne furent pas ontraints à quitter l’Inde. Ils choisirent au lieu de ça de transférer le territoire d'une administration coloniale directe à une administration néocoloniale**. Quelle sorte de victoire autorise les perdants à dicter le calendrier et les modalités de l’ascension des vainqueurs ? Les Britanniques rédigèrent la nouvelle constitution et remirent le pouvoir entre les mains de successeurs qu’ils choisirent. Ils attisèrent les flammes du séparatisme ethnique et religieux afin que l’Inde soit affaiblie par des divisions internes, empêchée de bénéficier de la paix et de la prospérité, et dépendante de l’aide militaire et autres formes de soutien de la part des États euro-américains.

> **L’Inde est toujours exploitée par des entreprises euro-américaines** (bien que plusieurs nouvelles entreprises indiennes, principalement des filiales, se soient jointes au pillage), et continue de fournir des ressources et des marchés aux États impérialistes. Par bien des façons, **la pauvreté de son peuple s’est aggravée et l’exploitation est devenue plus efficace**. L’indépendance à l’égard du pouvoir colonial a donné à l’Inde plus d’autonomie dans quelques zones, et a certainement permis à une poignée d’Indiens de s’asseoir dans les fauteuils du pouvoir, mais **l’exploitation et la marchandisation des ressources s’est approfondie**. Qui plus est, l’Inde a perdu la nette opportunité que représentait une lutte d’émancipation riche de sens menée contre un oppresseur étranger aisément identifiable. Aujourd’hui, un mouvement d’émancipation aurait a s’opposer aux dynamiques déconcertantes du nationalisme et de la rivalité ethnique et religieuse pour abolir un capitalisme et un gouvernement domestiques bien plus développés que dans leurs formes d’alors. Tout bien pesé, le mouvement d’indépendance a donc bien échoué.
